//+----------------------------------------------------------------------------------+
//|                                                                                  |
//|                                Price Lines.mq4                                   |
//|                                                                                  |
//+----------------------------------------------------------------------------------+

#property copyright "For JL Use"
#property link      "JL"


#property indicator_chart_window

extern bool   Indicator_On                    = true;
extern int    RangesAboveBelowBaseRange       = 100;
extern string Exit_Period_Choices             = "M1, M5, M15, M30, H1, H4, D, W, M";
extern string Exit_If_Period_Greater_Than     = "M";

extern string _                               = "";
extern string Part_1                          = "Line Settings:";
extern bool   EndLines_At_Current_Candle      = false;
extern bool   FScrLines_With_Margin_Prices    = false;
extern bool   Subordinate_Lines               = true;

extern string __                              = "";
extern string Part_2                          = "Label Settings:";
extern color  Color                           = MidnightBlue;
extern bool   ShowLabels                      = false;
extern string FontStyle                       = "Arial";
extern int    FontSize                        = 11;          
extern bool   Line_Prices                     = false;
extern string Text_For_Label                  = "";
extern int    Shift_Labels_PerCent_Left       = 0;    
extern bool   Subordinate_Labels              = false;

extern string ___                             = "";
extern string Part_3                          = "Individual Line Configurations:";
extern color  Line1_Color                     = Black;
extern bool   Line1_On                        = true;
extern int    Line1_Last_Two_Digits           = 0;
extern int    Line1_Style_01234               = 0;
extern int    Line1_SolidThickness            = 3;

extern color  Line2_Color                     = Black;  //C'193,193,0';
extern bool   Line2_On                        = true;
extern int    Line2_Last_Two_Digits           = 50;
extern int    Line2_Style_01234               = 1;
extern int    Line2_SolidThickness            = 0;

extern color  Line3_Color                     = Black;
extern bool   Line3_On                        = false;  
extern int    Line3_Last_Two_Digits           = 17;
extern int    Line3_Style_01234               = 2;
extern int    Line3_SolidThickness            = 1;

extern color  Line4_Color                     = Black;
extern bool   Line4_On                        = false;
extern int    Line4_Last_Two_Digits           = 83;
extern int    Line4_Style_01234               = 2;
extern int    Line4_SolidThickness            = 1;

extern color  Line5_Color                     = Black;
extern bool   Line5_On                        = false;
extern int    Line5_Last_Two_Digits           = 67;
extern int    Line5_Style_01234               = 2;
extern int    Line5_SolidThickness            = 1;

extern color  Line6_Color                     = Black;
extern bool   Line6_On                        = false;
extern int    Line6_Last_Two_Digits           = 33;
extern int    Line6_Style_01234               = 2;
extern int    Line6_SolidThickness            = 1;

double Poin;

//+-------------------------------------------------------------------------------------------+
//| Initialization                                                                            |
//+-------------------------------------------------------------------------------------------+
int init()
{ 
   //Checking for unconventional Point digits number
   if (Point == 0.00001) Poin = 0.0001; //5 digits
   else if (Point == 0.001) Poin = 0.01; //3 digits
   else Poin = Point; //Normal
   return(0);
}

//+-------------------------------------------------------------------------------------------+
//| De-initialization                                                                         |
//+-------------------------------------------------------------------------------------------+
int deinit()  
{
   int obj_total= ObjectsTotal();  
   for (int j= obj_total; j>=0; j--) 
      {
      string name= ObjectName(j);    
      if (StringSubstr(name,0,14)=="[Prime Levels]"){ObjectDelete(name);}
      }      
   return(0);
}

//+-------------------------------------------------------------------------------------------+
//| Start                                                                                     |
//+-------------------------------------------------------------------------------------------+
int start()
{
   deinit();if (Indicator_On == false) {return(0);} 
          
   //Exit if period is greater than
   int E;
   if(Exit_If_Period_Greater_Than== "M1") {E= 1;}
   if(Exit_If_Period_Greater_Than== "M5") {E= 5;}
   if(Exit_If_Period_Greater_Than== "M15"){E= 15;}
   if(Exit_If_Period_Greater_Than== "M30"){E= 30;}
   if(Exit_If_Period_Greater_Than== "H1") {E= 60;}
   if(Exit_If_Period_Greater_Than== "H4") {E= 240;}
   if(Exit_If_Period_Greater_Than== "D")  {E= 1440;}
   if(Exit_If_Period_Greater_Than== "W")  {E= 10080;}
   if(Exit_If_Period_Greater_Than== "M")  {E= 43200;}
   if(Period() > E) {deinit(); return(-1);} 

   //initialize needed variables
   int i, ssp, ssp1;  //choosing "int" instead of "double" drops decimal portion of value
   double linelevel, linestyle ,linewidth; color linecolor;
   double d1=Bid;  //Comment(DoubleToStr(NormalizeDouble(d1,2),2));
   ssp1= Bid;  //bid w/o decimal, 117 instead of 117.66
   ssp1= Bid / Poin;  //Point restores bid integers w/o the decimal, 11766   
   int u1 = Line1_Last_Two_Digits; //initializing last two digits user entered
   int u2 = Line2_Last_Two_Digits;
   int u3 = Line3_Last_Two_Digits;
   int u4 = Line4_Last_Two_Digits;
   int u5 = Line5_Last_Two_Digits;
   int u6 = Line6_Last_Two_Digits;      
   int c1=ssp1%100;  
   double LA, LB, LN; LN=100-c1; LB=c1; LA=LN; //if (c1<50)LB=c1;LA=LN;//if (c1>+50)LB=c1;LA=LN;Comment(LB);

   //calculate line levels for user specified # of ranges
   ssp=ssp1; //start ssp at reference bid
   for (i= -((100*(RangesAboveBelowBaseRange))+LB); i<=((100*(RangesAboveBelowBaseRange))+LA); i++)   
      {
         ssp=ssp1+i;  //Comment(i+"  "+ssp);
         c1=ssp%100;  //Comment(c1);
         if (c1==u1 && Line1_On == true)
            {           
            linestyle = Line1_Style_01234;
            linecolor = Line1_Color;
            linewidth = Line1_SolidThickness;
            linelevel = ssp*Poin;
            }
         if (c1==u2 && Line2_On == true)
            {           
            linestyle = Line2_Style_01234;
            linecolor = Line2_Color;
            linewidth = Line2_SolidThickness;
            linelevel = ssp*Poin;
            }
         if (c1==u3 && Line3_On == true)
            {           
            linestyle = Line3_Style_01234;
            linecolor = Line3_Color;
            linewidth = Line3_SolidThickness;
            linelevel = ssp*Poin;
            }
         if (c1==u4 && Line4_On == true)
            {           
            linestyle = Line4_Style_01234;
            linecolor = Line4_Color;
            linewidth = Line4_SolidThickness;
            linelevel = ssp*Poin;
            }
         if (c1==u5 && Line5_On == true)
            {           
            linestyle = Line5_Style_01234;
            linecolor = Line5_Color;
            linewidth = Line5_SolidThickness;
            linelevel = ssp*Poin;
            }
         if (c1==u6 && Line6_On == true)
            {           
            linestyle = Line6_Style_01234;
            linecolor = Line6_Color;
            linewidth = Line6_SolidThickness;
            linelevel = ssp*Poin;
            }

         //branch to subroutine to draw lines
         SetLevel(DoubleToStr(linelevel,Digits), linelevel,  linecolor, linestyle, linewidth, Time[10]);
         
         //branch to subroutine to draw labels
         if(ShowLabels == true){SetLabel(DoubleToStr(linelevel,Digits), linelevel, Color);}
      }
     
   return(0);
   }
   
//+-------------------------------------------------------------------------------------------+
//| Sub-routine to name and draw lines                                                        |                                                                                  |
//+---------------------------------------------------------------------------------------- --+
void SetLevel(string text, double level, color linecolor, int linestyle, int linewidth, datetime startofday)
{
   int digits=Digits;  
   int startline = WindowFirstVisibleBar(); 
   int endline = Time[0];
   int G = false;
   int Z= OBJ_TREND;
   string linename= "[Prime Levels] " + StringTrimLeft(text) + " Line"; 
     
   // create or move the horizontal line 
   if( FScrLines_With_Margin_Prices == true){Z = OBJ_HLINE;}
   if (EndLines_At_Current_Candle) {startline= Time[0]; endline= WindowFirstVisibleBar(); Z= OBJ_TREND;} 
   if (Subordinate_Lines) {G = true;} 
   if (ObjectFind(linename) != 0)
      {
      ObjectCreate(linename,  Z, 0, startline, level, endline, level); 
      ObjectSet(linename, OBJPROP_STYLE, linestyle);     
      ObjectSet(linename, OBJPROP_COLOR, linecolor);
      ObjectSet(linename, OBJPROP_WIDTH, linewidth);
      ObjectSet(linename, OBJPROP_BACK, G); 
      }
   else 
      {
      ObjectMove(linename, 0, startline, level);
      ObjectMove(linename, 1, endline, level);
      }
}

//+-------------------------------------------------------------------------------------------+
//| Sub-routine to name and draw labels                                                       |                                                                                  |
//+---------------------------------------------------------------------------------------- --+
void SetLabel(string text, double linelevel, color Color_Labels)
{
   int ml = ((WindowFirstVisibleBar()-0) * Shift_Labels_PerCent_Left)/ 100; 
   int G = false;
   string Font;
   string name = "[Prime Levels] " + StringTrimLeft(text) + " Label";
   string TEXT = Text_For_Label;
   if (Line_Prices == true){TEXT = TEXT + "   "+DoubleToStr(linelevel, Digits);}  
   if (Subordinate_Labels) {G = true;} 
   
   for (int i = StringLen(TEXT)*2+2; i >= 0; i--) string tab = tab + " ";
   
   if(ObjectFind(name) != 0)
      {
      ObjectCreate(name, OBJ_TEXT, 0, Time[ml], linelevel);       
      ObjectSet(name, OBJPROP_BACK, G);
      ObjectSetText(name, tab+TEXT, FontSize, FontStyle, Color_Labels);
      }
      else
      {
      ObjectMove(name, 0, Time[ml], linelevel);
      }
}

//+-------------------------------------------------------------------------------------------+
//| End                                                                                       |                                                        
//+-------------------------------------------------------------------------------------------+
    